Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_rand.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_rand.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_rand.h	(revision 389)
@@ -0,0 +1,19 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef GB_RAND_H
+#define GB_RAND_H
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+MOCKABLE_FUNCTION(, int, gb_rand);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* GB_RAND_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_stdio.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_stdio.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_stdio.h	(revision 389)
@@ -0,0 +1,69 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef GB_STDIO_H
+#define GB_STDIO_H
+
+/*this file, if included instead of <stdio.h> has the following functionality:
+1) if GB_STDIO_INTERCEPT is defined then
+    a) some of the stdio.h symbols shall be redefined, for example: fopen => gb_fopen
+    b) all "code" using the fopen will actually (because of the preprocessor) call to gb_fopen
+    c) gb_fopen shall blindly call into fopen, thus realizing a passthrough
+    
+    reason is: unittesting. fopen is comes with the C Run Time and cannot be mocked (that is, in the global namespace cannot exist a function called fopen
+
+2) if GB_STDIO_INTERCEPT is not defined then
+    a) it shall include <stdio.h> => no passthrough, just direct linking.
+*/
+
+#ifndef GB_STDIO_INTERCEPT
+#include <stdio.h>
+#else
+
+/*source level intercepting of function calls*/
+#define fopen           fopen_never_called_never_implemented_always_forgotten
+#define fclose          fclose_never_called_never_implemented_always_forgotten
+#define fseek           fseek_never_called_never_implemented_always_forgotten
+#define ftell           ftell_never_called_never_implemented_always_forgotten
+#define fprintf         fprintf_never_called_never_implemented_always_forgotten
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+
+#ifdef __cplusplus
+#include <cstdio.h>
+extern "C"
+{
+#else
+#include <stdio.h>
+#endif
+
+#undef fopen
+#define fopen gb_fopen
+MOCKABLE_FUNCTION(, FILE*, gb_fopen, const char*, filename, const char*, mode);
+
+
+#undef fclose
+#define fclose gb_fclose
+MOCKABLE_FUNCTION(, int, fclose, FILE *, stream);
+
+#undef fseek
+#define fseek gb_fseek
+MOCKABLE_FUNCTION(, int, fseek, FILE *,stream, long int, offset, int, whence);
+
+#undef ftell
+#define ftell gb_ftell
+MOCKABLE_FUNCTION(, long int, ftell, FILE *, stream);
+
+#undef fprintf
+#define fprintf gb_fprintf
+extern int fprintf(FILE * stream, const char * format, ...);
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /*GB_STDIO_INTERCEPT*/
+
+#endif /* GB_STDIO_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_time.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_time.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gb_time.h	(revision 389)
@@ -0,0 +1,57 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef GB_TIME_H
+#define GB_TIME_H
+
+/*this file, if included instead of <stdio.h> has the following functionality:
+1) if GB_TIME_INTERCEPT is defined then
+    a) some of the time.h symbols shall be redefined, for example: time => gb_time
+    b) all "code" using the time will actually (because of the preprocessor) call to gb_time
+    c) gb_time shall blindly call into time, thus realizing a passthrough
+    
+    reason is: unittesting. time comes with the C Run Time and cannot be mocked (that is, in the global namespace cannot exist a function called time
+
+2) if GB_TIME_INTERCEPT is not defined then
+    a) it shall include <time.h> => no passthrough, just direct linking.
+*/
+
+#ifndef GB_TIME_INTERCEPT
+#include <time.h>
+#else
+
+/*source level intercepting of function calls*/
+#define time                    time_never_called_never_implemented_always_forgotten
+#define localtime               localtime_never_called_never_implemented_always_forgotten
+#define strftime                strftime_never_called_never_implemented_always_forgotten
+
+#ifdef __cplusplus
+#include <ctime.h>
+extern "C"
+{
+#else
+#include <time.h>
+#endif
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#undef time
+#define time gb_time
+MOCKABLE_FUNCTION(, time_t, time, time_t *, timer);
+
+#undef localtime
+#define localtime gb_localtime
+MOCKABLE_FUNCTION(, struct tm *, localtime, const time_t *, timer);
+
+#undef strftime
+#define strftime gb_strftime
+MOCKABLE_FUNCTION(, size_t, strftime, char *, s, size_t, maxsize, const char *, format, const struct tm *, timeptr);
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /*GB_TIME_INTERCEPT*/
+
+#endif /* GB_TIME_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gballoc.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gballoc.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gballoc.h	(revision 389)
@@ -0,0 +1,86 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef GBALLOC_H
+#define GBALLOC_H
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+#include <cstdlib>
+extern "C"
+{
+#else
+#include <stddef.h>
+#include <stdlib.h>
+#endif
+
+// GB_USE_CUSTOM_HEAP disables the implementations in gballoc.c and
+// requires that an external library implement the gballoc_malloc family
+// declared here.
+#if defined(GB_USE_CUSTOM_HEAP)
+MOCKABLE_FUNCTION(, void*, gballoc_malloc, size_t, size);
+MOCKABLE_FUNCTION(, void*, gballoc_calloc, size_t, nmemb, size_t, size);
+MOCKABLE_FUNCTION(, void*, gballoc_realloc, void*, ptr, size_t, size);
+MOCKABLE_FUNCTION(, void, gballoc_free, void*, ptr);
+
+#define malloc gballoc_malloc
+#define calloc gballoc_calloc
+#define realloc gballoc_realloc
+#define free gballoc_free
+
+/* all translation units that need memory measurement need to have GB_MEASURE_MEMORY_FOR_THIS defined */
+/* GB_DEBUG_ALLOC is the switch that turns the measurement on/off, so that it is not on always */
+#elif defined(GB_DEBUG_ALLOC)
+
+MOCKABLE_FUNCTION(, int, gballoc_init);
+MOCKABLE_FUNCTION(, void, gballoc_deinit);
+MOCKABLE_FUNCTION(, void*, gballoc_malloc, size_t, size);
+MOCKABLE_FUNCTION(, void*, gballoc_calloc, size_t, nmemb, size_t, size);
+MOCKABLE_FUNCTION(, void*, gballoc_realloc, void*, ptr, size_t, size);
+MOCKABLE_FUNCTION(, void, gballoc_free, void*, ptr);
+
+MOCKABLE_FUNCTION(, size_t, gballoc_getMaximumMemoryUsed);
+MOCKABLE_FUNCTION(, size_t, gballoc_getCurrentMemoryUsed);
+MOCKABLE_FUNCTION(, size_t, gballoc_getAllocationCount);
+MOCKABLE_FUNCTION(, void, gballoc_resetMetrics);
+
+/* if GB_MEASURE_MEMORY_FOR_THIS is defined then we want to redirect memory allocation functions to gballoc_xxx functions */
+#ifdef GB_MEASURE_MEMORY_FOR_THIS
+/* Unfortunately this is still needed here for things to still compile when using _CRTDBG_MAP_ALLOC.
+That is because there is a rogue component (most likely CppUnitTest) including crtdbg. */
+#if defined(_CRTDBG_MAP_ALLOC) && defined(_DEBUG)
+#undef _malloc_dbg
+#undef _calloc_dbg
+#undef _realloc_dbg
+#undef _free_dbg
+#define _malloc_dbg(size, ...) gballoc_malloc(size)
+#define _calloc_dbg(nmemb, size, ...) gballoc_calloc(nmemb, size)
+#define _realloc_dbg(ptr, size, ...) gballoc_realloc(ptr, size)
+#define _free_dbg(ptr, ...) gballoc_free(ptr)
+#else
+#define malloc gballoc_malloc
+#define calloc gballoc_calloc
+#define realloc gballoc_realloc
+#define free gballoc_free
+#endif
+#endif
+
+#else /* GB_DEBUG_ALLOC */
+
+#define gballoc_init() 0
+#define gballoc_deinit() ((void)0)
+
+#define gballoc_getMaximumMemoryUsed() SIZE_MAX
+#define gballoc_getCurrentMemoryUsed() SIZE_MAX
+#define gballoc_getAllocationCount() SIZE_MAX
+#define gballoc_resetMetrics() ((void)0)
+
+#endif /* GB_DEBUG_ALLOC */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* GBALLOC_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gbnetwork.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gbnetwork.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/gbnetwork.h	(revision 389)
@@ -0,0 +1,74 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef GBNETWORK_H
+#define GBNETWORK_H
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+#include <cstdlib>
+#include <cstdint>
+extern "C"
+{
+#else
+#include <stddef.h>
+#include <stdlib.h>
+#include <stdint.h>
+#endif
+
+#ifdef WIN32
+    #include <winsock2.h>
+#else
+    #include <sys/socket.h>
+#endif
+
+/* all translation units that need network measurement need to have GB_MEASURE_NETWORK_FOR_THIS defined */
+/* GB_DEBUG_NETWORK is the switch that turns the measurement on/off, so that it is not on always */
+#if defined(GB_DEBUG_NETWORK)
+
+MOCKABLE_FUNCTION(, int, gbnetwork_init);
+MOCKABLE_FUNCTION(, void, gbnetwork_deinit);
+
+#ifdef WIN32
+MOCKABLE_FUNCTION(, int, gbnetwork_send, SOCKET, sock, const char*, buf, int, len, int, flags);
+#else
+MOCKABLE_FUNCTION(, ssize_t, gbnetwork_send, int, sock, const void*, buf, size_t, len, int, flags);
+#endif
+
+#ifdef WIN32
+MOCKABLE_FUNCTION(, int, gbnetwork_recv, SOCKET, sock, char*, buf, int, len, int, flags);
+#else
+MOCKABLE_FUNCTION(, ssize_t, gbnetwork_recv, int, sock, void*, buf, size_t, len, int, flags);
+#endif
+
+MOCKABLE_FUNCTION(, uint64_t, gbnetwork_getBytesSent);
+MOCKABLE_FUNCTION(, uint64_t, gbnetwork_getNumSends);
+MOCKABLE_FUNCTION(, uint64_t, gbnetwork_getBytesRecv);
+MOCKABLE_FUNCTION(, uint64_t, gbnetwork_getNumRecv);
+MOCKABLE_FUNCTION(, void, gbnetwork_resetMetrics);
+
+/* if GB_MEASURE_NETWORK_FOR_THIS is defined then we want to redirect network send functions to gbnetwork_xxx functions */
+#ifdef GB_MEASURE_NETWORK_FOR_THIS
+#define send gbnetwork_send
+#define recv gbnetwork_recv
+#endif
+
+#else /* GB_DEBUG_NETWORK */
+
+#define gbnetwork_init() 0
+#define gbnetwork_deinit() ((void)0)
+#define gbnetwork_getBytesSent() 0
+#define gbnetwork_getNumSends() 0
+
+#define gbnetwork_getBytesRecv() 0
+#define gbnetwork_getNumRecv() 0
+
+#endif /* GB_DEBUG_NETWORK */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* GBNETWORK_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/hmac.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/hmac.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/hmac.h	(revision 389)
@@ -0,0 +1,22 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef HMAC_H
+#define HMAC_H
+
+#include "azure_c_shared_utility/sha.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+    MOCKABLE_FUNCTION(, int, hmac, SHAversion, whichSha, const unsigned char *, text, int, text_len,
+    const unsigned char *, key, int, key_len,
+    uint8_t, digest[USHAMaxHashSize]);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* HMAC_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/hmacsha256.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/hmacsha256.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/hmacsha256.h	(revision 389)
@@ -0,0 +1,28 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef HMACSHA256_H
+#define HMACSHA256_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/buffer_.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define HMACSHA256_RESULT_VALUES              \
+    HMACSHA256_OK,                            \
+    HMACSHA256_INVALID_ARG,                   \
+    HMACSHA256_ERROR
+
+MU_DEFINE_ENUM(HMACSHA256_RESULT, HMACSHA256_RESULT_VALUES)
+
+MOCKABLE_FUNCTION(, HMACSHA256_RESULT, HMACSHA256_ComputeHash, const unsigned char*, key, size_t, keyLen, const unsigned char*, payload, size_t, payloadLen, BUFFER_HANDLE, hash);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* HMACSHA256_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/http_proxy_io.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/http_proxy_io.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/http_proxy_io.h	(revision 389)
@@ -0,0 +1,30 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef HTTP_PROXY_IO_H
+#define HTTP_PROXY_IO_H
+
+#include "azure_c_shared_utility/xio.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+typedef struct HTTP_PROXY_IO_CONFIG_TAG
+{
+    const char* hostname;
+    int port;
+    const char* proxy_hostname;
+    int proxy_port;
+    const char* username;
+    const char* password;
+} HTTP_PROXY_IO_CONFIG;
+
+MOCKABLE_FUNCTION(, const IO_INTERFACE_DESCRIPTION*, http_proxy_io_get_interface_description);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* HTTP_PROXY_IO_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapi.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapi.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapi.h	(revision 389)
@@ -0,0 +1,202 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file httpapi.h
+ *    @brief     This module implements the standard HTTP API used by the C IoT client
+ *             library.
+ *
+ *    @details For example, on the Windows platform the HTTP API code uses
+ *             WinHTTP and for Linux it uses curl and so forth. HTTPAPI must support
+ *             HTTPs (HTTP+SSL).
+ */
+
+#ifndef HTTPAPI_H
+#define HTTPAPI_H
+
+#include "azure_c_shared_utility/httpheaders.h"
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/buffer_.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C" {
+#else
+#include <stddef.h>
+#endif
+
+typedef struct HTTP_HANDLE_DATA_TAG* HTTP_HANDLE;
+
+#define AMBIGUOUS_STATUS_CODE           (300)
+
+#define HTTPAPI_RESULT_VALUES                \
+HTTPAPI_OK,                                  \
+HTTPAPI_INVALID_ARG,                         \
+HTTPAPI_ERROR,                               \
+HTTPAPI_OPEN_REQUEST_FAILED,                 \
+HTTPAPI_SET_OPTION_FAILED,                   \
+HTTPAPI_SEND_REQUEST_FAILED,                 \
+HTTPAPI_RECEIVE_RESPONSE_FAILED,             \
+HTTPAPI_QUERY_HEADERS_FAILED,                \
+HTTPAPI_QUERY_DATA_AVAILABLE_FAILED,         \
+HTTPAPI_READ_DATA_FAILED,                    \
+HTTPAPI_ALREADY_INIT,                        \
+HTTPAPI_NOT_INIT,                            \
+HTTPAPI_HTTP_HEADERS_FAILED,                 \
+HTTPAPI_STRING_PROCESSING_ERROR,             \
+HTTPAPI_ALLOC_FAILED,                        \
+HTTPAPI_INIT_FAILED,                         \
+HTTPAPI_INSUFFICIENT_RESPONSE_BUFFER,        \
+HTTPAPI_SET_X509_FAILURE,                    \
+HTTPAPI_SET_TIMEOUTS_FAILED                  \
+
+/** @brief Enumeration specifying the possible return values for the APIs in
+ *           this module.
+ */
+MU_DEFINE_ENUM(HTTPAPI_RESULT, HTTPAPI_RESULT_VALUES);
+
+#define HTTPAPI_REQUEST_TYPE_VALUES\
+    HTTPAPI_REQUEST_GET,            \
+    HTTPAPI_REQUEST_POST,           \
+    HTTPAPI_REQUEST_PUT,            \
+    HTTPAPI_REQUEST_DELETE,         \
+    HTTPAPI_REQUEST_PATCH,          \
+    HTTPAPI_REQUEST_HEAD            \
+
+
+/** @brief Enumeration specifying the HTTP request verbs accepted by
+ *    the HTTPAPI module.
+ */
+MU_DEFINE_ENUM(HTTPAPI_REQUEST_TYPE, HTTPAPI_REQUEST_TYPE_VALUES);
+
+#define MAX_HOSTNAME_LEN        65
+#define MAX_USERNAME_LEN        65
+#define MAX_PASSWORD_LEN        65
+
+/**
+ * @brief    Global initialization for the HTTP API component.
+ *
+ *            Platform specific implementations are expected to initialize
+ *            the underlying HTTP API stacks.
+ *
+ * @return    @c HTTPAPI_OK if initialization is successful or an error
+ *             code in case it fails.
+ */
+MOCKABLE_FUNCTION(, HTTPAPI_RESULT, HTTPAPI_Init);
+
+/** @brief    Free resources allocated in ::HTTPAPI_Init. */
+MOCKABLE_FUNCTION(, void, HTTPAPI_Deinit);
+
+/**
+ * @brief    Creates an HTTPS connection to the host specified by the @p
+ *             hostName parameter.
+ *
+ * @param    hostName    Name of the host.
+ *
+ *            This function returns a handle to the newly created connection.
+ *            You can use the handle in subsequent calls to execute specific
+ *            HTTP calls using ::HTTPAPI_ExecuteRequest.
+ *
+ * @return    A @c HTTP_HANDLE to the newly created connection or @c NULL in
+ *             case an error occurs.
+ */
+MOCKABLE_FUNCTION(, HTTP_HANDLE, HTTPAPI_CreateConnection, const char*, hostName);
+
+/**
+ * @brief    Closes a connection created with ::HTTPAPI_CreateConnection.
+ *
+ * @param    handle    The handle to the HTTP connection created via ::HTTPAPI_CreateConnection.
+ *
+ *             All resources allocated by ::HTTPAPI_CreateConnection should be
+ *             freed in ::HTTPAPI_CloseConnection.
+ */
+MOCKABLE_FUNCTION(, void, HTTPAPI_CloseConnection, HTTP_HANDLE, handle);
+
+/**
+ * @brief    Sends the HTTP request to the host and handles the response for
+ *             the HTTP call.
+ *
+ * @param    handle                     The handle to the HTTP connection created
+ *                                     via ::HTTPAPI_CreateConnection.
+ * @param    requestType                 Specifies which HTTP method is used (GET,
+ *                                     POST, DELETE, PUT, PATCH).
+ * @param    relativePath             Specifies the relative path of the URL
+ *                                     excluding the host name.
+ * @param    httpHeadersHandle         Specifies a set of HTTP headers (name-value
+ *                                     pairs) to be added to the
+ *                                     HTTP request. The @p httpHeadersHandle
+ *                                     handle can be created and setup with
+ *                                     the proper name-value pairs by using the
+ *                                     HTTPHeaders APIs available in @c
+ *                                     HTTPHeaders.h.
+ * @param    content                     Specifies a pointer to the request body.
+ *                                     This value is optional and can be @c NULL.
+ * @param    contentLength             Specifies the request body size (this is
+ *                                     typically added into the HTTP headers as
+ *                                     the Content-Length header). This value is
+ *                                     optional and can be 0.
+ * @param   statusCode               This is an out parameter, where
+ *                                     ::HTTPAPI_ExecuteRequest returns the status
+ *                                     code from the HTTP response (200, 201, 400,
+ *                                     401, etc.)
+ * @param    responseHeadersHandle    This is an HTTP headers handle to which
+ *                                     ::HTTPAPI_ExecuteRequest must add all the
+ *                                     HTTP response headers so that the caller of
+ *                                     ::HTTPAPI_ExecuteRequest can inspect them.
+ *                                     You can manipulate @p responseHeadersHandle
+ *                                     by using the HTTPHeaders APIs available in
+ *                                     @c HTTPHeaders.h
+ * @param    responseContent             This is a buffer that must be filled by
+ *                                     ::HTTPAPI_ExecuteRequest with the contents
+ *                                     of the HTTP response body. The buffer size
+ *                                     must be increased by the
+ *                                     ::HTTPAPI_ExecuteRequest implementation in
+ *                                     order to fit the response body.
+ *                                     ::HTTPAPI_ExecuteRequest must also handle
+ *                                     chunked transfer encoding for HTTP responses.
+ *                                     To manipulate the @p responseContent buffer,
+ *                                     use the APIs available in @c Strings.h.
+ *
+ * @return    @c HTTPAPI_OK if the API call is successful or an error
+ *             code in case it fails.
+ */
+MOCKABLE_FUNCTION(, HTTPAPI_RESULT, HTTPAPI_ExecuteRequest, HTTP_HANDLE, handle, HTTPAPI_REQUEST_TYPE, requestType, const char*, relativePath,
+                                             HTTP_HEADERS_HANDLE, httpHeadersHandle, const unsigned char*, content,
+                                             size_t, contentLength, unsigned int*, statusCode,
+                                             HTTP_HEADERS_HANDLE, responseHeadersHandle, BUFFER_HANDLE, responseContent);
+
+/**
+ * @brief    Sets the option named @p optionName bearing the value
+ *             @p value for the HTTP_HANDLE @p handle.
+ *
+ * @param    handle          The handle to the HTTP connection created via
+ *                         ::HTTPAPI_CreateConnection.
+ * @param    optionName    A @c NULL terminated string representing the name
+ *                         of the option.
+ * @param    value          A pointer to the value for the option.
+ *
+ * @return    @c HTTPAPI_OK if initialization is successful or an error
+ *             code in case it fails.
+ */
+MOCKABLE_FUNCTION(, HTTPAPI_RESULT, HTTPAPI_SetOption, HTTP_HANDLE, handle, const char*, optionName, const void*, value);
+
+/**
+ * @brief    Clones the option named @p optionName bearing the value @p value
+ *             into the pointer @p savedValue.
+ *
+ * @param    optionName    A @c NULL terminated string representing the name of
+ *                         the option
+ * @param    value          A pointer to the value of the option.
+ * @param    savedValue    This pointer receives the copy of the value of the
+ *                         option. The copy needs to be free-able.
+ *
+ * @return    @c HTTPAPI_OK if initialization is successful or an error
+ *             code in case it fails.
+ */
+MOCKABLE_FUNCTION(, HTTPAPI_RESULT, HTTPAPI_CloneOption, const char*, optionName, const void*, value, const void**, savedValue);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* HTTPAPI_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapiex.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapiex.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapiex.h	(revision 389)
@@ -0,0 +1,106 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file httpapiex.h
+*	@brief		This is a utility module that provides HTTP requests with
+*				build-in retry capabilities.
+*
+*	@details	HTTAPIEX is a utility module that provides HTTP requests with build-in
+*				retry capability to an HTTP server. Features over "regular" HTTPAPI include:
+*					- Optional parameters
+*					- Implementation independent
+*					- Retry mechanism
+*					- Persistent options
+*/
+
+#ifndef HTTPAPIEX_H
+#define HTTPAPIEX_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/httpapi.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+ 
+#ifdef __cplusplus
+#include <cstddef>
+extern "C" {
+#else
+#include <stddef.h>
+#endif
+
+typedef struct HTTPAPIEX_HANDLE_DATA_TAG* HTTPAPIEX_HANDLE;
+
+#define HTTPAPIEX_RESULT_VALUES \
+    HTTPAPIEX_OK, \
+    HTTPAPIEX_ERROR, \
+    HTTPAPIEX_INVALID_ARG, \
+    HTTPAPIEX_RECOVERYFAILED
+/*to be continued*/
+
+/** @brief Enumeration specifying the status of calls to various APIs in this module.
+*/
+MU_DEFINE_ENUM(HTTPAPIEX_RESULT, HTTPAPIEX_RESULT_VALUES);
+
+/**
+ * @brief	Creates an @c HTTPAPIEX_HANDLE that can be used in further calls.
+ *
+ * @param	hostName	Pointer to a null-terminated string that contains the host name
+ * 						of an HTTP server.
+ * 						
+ *			If @p hostName is @c NULL then @c HTTPAPIEX_Create returns @c NULL. The @p
+ *			hostName value is saved and associated with the returned handle. If creating
+ *			the handle fails for any reason, then @c HTTAPIEX_Create returns @c NULL.
+ *			Otherwise, @c HTTPAPIEX_Create returns an @c HTTAPIEX_HANDLE suitable for
+ *			further calls to the module.
+ *
+ * @return	An @c HTTAPIEX_HANDLE suitable for further calls to the module.
+ */
+MOCKABLE_FUNCTION(, HTTPAPIEX_HANDLE, HTTPAPIEX_Create, const char*, hostName);
+
+/**
+ * @brief	Tries to execute an HTTP request.
+ *
+ * @param	handle					 	A valid @c HTTPAPIEX_HANDLE value.
+ * @param	requestType				 	A value from the ::HTTPAPI_REQUEST_TYPE enum.
+ * @param	relativePath			 	Relative path to send the request to on the server.
+ * @param	requestHttpHeadersHandle 	Handle to the request HTTP headers.
+ * @param	requestContent			 	The request content.
+ * @param 	statusCode		 	        If non-null, the HTTP status code is written to this
+ * 										pointer.
+ * @param	responseHttpHeadersHandle	Handle to the response HTTP headers.
+ * @param	responseContent			 	The response content.
+ * 										
+ * 			@c HTTPAPIEX_ExecuteRequest tries to execute an HTTP request of type @p
+ * 			requestType, on the server's @p relativePath, pushing the request HTTP
+ * 			headers @p requestHttpHeadersHandle, having the content of the request
+ * 			as pointed to by @p requestContent. If successful,  @c HTTAPIEX_ExecuteRequest
+ * 			writes in the out @p parameter statusCode the HTTP status, populates the @p
+ * 			responseHeadersHandle with the response headers and copies the response body
+ * 			to @p responseContent.
+ *
+ * @return	An @c HTTAPIEX_HANDLE suitable for further calls to the module.
+ */
+MOCKABLE_FUNCTION(, HTTPAPIEX_RESULT, HTTPAPIEX_ExecuteRequest, HTTPAPIEX_HANDLE, handle, HTTPAPI_REQUEST_TYPE, requestType, const char*, relativePath, HTTP_HEADERS_HANDLE, requestHttpHeadersHandle, BUFFER_HANDLE, requestContent, unsigned int*, statusCode, HTTP_HEADERS_HANDLE, responseHttpHeadersHandle, BUFFER_HANDLE, responseContent);
+
+/**
+ * @brief	Frees all resources used by the @c HTTPAPIEX_HANDLE object.
+ *
+ * @param	handle	The @c HTTPAPIEX_HANDLE object to be freed.
+ */
+MOCKABLE_FUNCTION(, void, HTTPAPIEX_Destroy, HTTPAPIEX_HANDLE, handle);
+
+/**
+ * @brief	Sets the option @p optionName to the value pointed to by @p value.
+ *
+ * @param	handle	  	The @c HTTPAPIEX_HANDLE representing this session.
+ * @param	optionName	Name of the option.
+ * @param	value	  	The value to be set for the option.
+ *
+ * @return	An @c HTTPAPIEX_RESULT indicating the status of the call.
+ */
+MOCKABLE_FUNCTION(, HTTPAPIEX_RESULT, HTTPAPIEX_SetOption, HTTPAPIEX_HANDLE, handle, const char*, optionName, const void*, value);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* HTTPAPIEX_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapiexsas.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapiexsas.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpapiexsas.h	(revision 389)
@@ -0,0 +1,32 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef HTTPAPIEX_SAS_H
+#define HTTPAPIEX_SAS_H
+
+#include "azure_c_shared_utility/strings.h"
+#include "azure_c_shared_utility/buffer_.h"
+#include "azure_c_shared_utility/httpheaders.h"
+#include "azure_c_shared_utility/httpapiex.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+
+typedef struct HTTPAPIEX_SAS_STATE_TAG* HTTPAPIEX_SAS_HANDLE;
+
+MOCKABLE_FUNCTION(, HTTPAPIEX_SAS_HANDLE, HTTPAPIEX_SAS_Create, STRING_HANDLE, key, STRING_HANDLE, uriResource, STRING_HANDLE, keyName);
+
+MOCKABLE_FUNCTION(, HTTPAPIEX_SAS_HANDLE, HTTPAPIEX_SAS_Create_From_String, const char*, key, const char*, uriResource, const char*, keyName);
+
+MOCKABLE_FUNCTION(, void, HTTPAPIEX_SAS_Destroy, HTTPAPIEX_SAS_HANDLE, handle);
+
+MOCKABLE_FUNCTION(, HTTPAPIEX_RESULT, HTTPAPIEX_SAS_ExecuteRequest, HTTPAPIEX_SAS_HANDLE, sasHandle, HTTPAPIEX_HANDLE, handle, HTTPAPI_REQUEST_TYPE, requestType, const char*, relativePath, HTTP_HEADERS_HANDLE, requestHttpHeadersHandle, BUFFER_HANDLE, requestContent, unsigned int*, statusCode, HTTP_HEADERS_HANDLE, responseHeadersHandle, BUFFER_HANDLE, responseContent);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* HTTPAPIEX_SAS_H */
